/*
    ServerWiper, watch a Source server to punish bad behaviour
    Copyright (C) 2007-2008  Jonathan "Jmgr" Mercier-Ganady

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact e-mail : sw@jmgr.info
*/

#ifndef _INCLUDE_CVARS_H
#define _INCLUDE_CVARS_H

#include <convar.h>

class ConCommandAccessor : public IConCommandBaseAccessor
{
public:
	virtual bool RegisterConCommandBase(ConCommandBase *pVar);
};

#define CVAR_BOOL(x) (atoi(x.GetString()))//FIX to enable debug build under GCC
#define CVAR_INT(x) CVAR_BOOL(x)//FIX to enable debug build under GCC

extern ConCommandAccessor g_Accessor;

extern ConVar g_ServerWiperVersion;
extern ConVar g_ServerWiperEnabled;
extern ConVar g_ShortServerName;
extern ConVar g_Language;
extern ConVar g_TeamAttack;
extern ConVar g_TeamKill;
extern ConVar g_TeamFlash;
extern ConVar g_Insult;
extern ConVar g_ApologyTeamAttack;
extern ConVar g_ApologyTeamKill;
extern ConVar g_ApologyTeamFlash;
extern ConVar g_ApologyInsult;
extern ConVar g_BombPlant;
extern ConVar g_BombDefuse;
extern ConVar g_HostageAttack;
extern ConVar g_HostageKill;
extern ConVar g_HostageFollow;
extern ConVar g_HostageRescue;
extern ConVar g_Greetings;
extern ConVar g_MessageBoxTime;
extern ConVar g_DebugLevel;
extern ConVar g_Advert;
extern ConVar g_AdvertDelay;
extern ConVar g_HelpMessages;
extern ConVar g_HelpMessagesDelay;
extern ConVar g_Register;
//extern ConVar g_UseMessageBoxes;
extern ConVar g_SendBanURL;
extern ConVar g_SendAdminBans;
extern ConVar g_StatusCommand;
extern ConVar g_AllowStatus;
//extern ConVar g_SettingsCommand;
//extern ConVar g_AllowSettings;
extern ConVar g_HideSayCommands;
extern ConVar g_HideSayInsults;
extern ConVar g_DisableChat;
extern ConVar g_WelcomeMessage;
extern ConVar g_ShowStatusOnDeath;
extern ConVar g_CheckPlayersName;
extern ConVar g_BanRecoveryPlaytime;
extern ConVar g_ForgiveTkMenu;
extern ConVar g_ForgiveTkMenuTime;
extern ConVar g_SavePlayersAtRoundStart;
extern ConVar g_UseDelaysToLimitApologies;
extern ConVar g_DetectManiAdminPluginBans;
extern ConVar g_DetectSourceModBans;
extern ConVar g_RemindPlayersWithBadBehaviour;
extern ConVar g_SoundToPlayWhenReminding;
extern ConVar g_ShowSteamIdOnConnect;
extern ConVar g_TeamMembersTagCheck;
extern ConVar g_TeamMembersTag;
extern ConVar g_DatabaseCleanDelay;

extern ConVar g_PointLossRatio;
extern ConVar g_PointLossRatioDelay;
extern ConVar g_PointLossRatioMax;

extern ConVar g_PunishAtRoundStart;
extern ConVar g_PunishAtRoundStartDelay;
extern ConVar g_PunishAtRoundStartRatio;

extern ConVar g_PunishLeavers;
extern ConVar g_PunishLeaversDelay;
extern ConVar g_PunishLeaversBanPoints;

extern ConVar g_AllowedNamesCheck;
extern ConVar g_AllowedCharactersInName;
extern ConVar g_MinAllowedCharactersInName;

extern ConVar g_MaxBehavPoints;
extern ConVar g_MaxBanPoints;
extern ConVar g_BehavPointsKickSteps;

extern ConVar g_CountTAWhenDead;
extern ConVar g_CountTKWhenDead;
extern ConVar g_CountTFWhenDead;
extern ConVar g_CountHostageAttackWhenDead;
extern ConVar g_CountHostageKillWhenDead;

extern ConVar g_TeamAttackDelay;
extern ConVar g_HostageAttackDelay;
extern ConVar g_TeamAttackApologyDelay;
extern ConVar g_TeamFlashApologyDelay;
extern ConVar g_TeamKillApologyDelay;
extern ConVar g_InsultApologyDelay;
extern ConVar g_GreetingsDelay;
extern ConVar g_InvalidCharacters;
extern ConVar g_GreetingsTime;
extern ConVar g_TeamAttackApologyTime;
extern ConVar g_TeamFlashApologyTime;
extern ConVar g_TeamKillApologyTime;
extern ConVar g_InsultApologyTime;

extern ConVar g_TeamAttackSteps;
extern ConVar g_BehaviourPointsTeamAttack;
extern ConVar g_BanPointsTeamAttack;
extern ConVar g_MoneyTeamAttack;
extern ConVar g_HealthTeamAttack;

extern ConVar g_BehaviourPointsTeamKill;
extern ConVar g_BanPointsTeamKill;
extern ConVar g_MoneyTeamKill;
extern ConVar g_HealthTeamKill;

extern ConVar g_BehaviourPointsInsult;
extern ConVar g_BanPointsInsult;
extern ConVar g_MoneyInsult;
extern ConVar g_HealthInsult;

extern ConVar g_BehaviourPointsTeamAttackApology;
extern ConVar g_BanPointsTeamAttackApology;
extern ConVar g_MoneyTeamAttackApology;
extern ConVar g_HealthTeamAttackApology;

extern ConVar g_BehaviourPointsTeamKillApology;
extern ConVar g_BanPointsTeamKillApology;
extern ConVar g_MoneyTeamKillApology;
extern ConVar g_HealthTeamKillApology;

extern ConVar g_BehaviourPointsInsultApology;
extern ConVar g_BanPointsInsultApology;
extern ConVar g_MoneyInsultApology;
extern ConVar g_HealthInsultApology;

extern ConVar g_BehaviourPointsBombPlant;
extern ConVar g_BanPointsBombPlant;
extern ConVar g_MoneyBombPlant;
extern ConVar g_HealthBombPlant;

extern ConVar g_BehaviourPointsBombDefuse;
extern ConVar g_BanPointsBombDefuse;
extern ConVar g_MoneyBombDefuse;
extern ConVar g_HealthBombDefuse;

extern ConVar g_BehaviourPointsHostageAttack;
extern ConVar g_BanPointsHostageAttack;
extern ConVar g_MoneyHostageAttack;
extern ConVar g_HealthHostageAttack;

extern ConVar g_BehaviourPointsHostageKill;
extern ConVar g_BanPointsHostageKill;
extern ConVar g_MoneyHostageKill;
extern ConVar g_HealthHostageKill;

extern ConVar g_BehaviourPointsHostageFollow;
extern ConVar g_BanPointsHostageFollow;
extern ConVar g_MoneyHostageFollow;
extern ConVar g_HealthHostageFollow;
extern ConVar g_MaxHostageFollowInRound;

extern ConVar g_BehaviourPointsHostageRescue;
extern ConVar g_BanPointsHostageRescue;
extern ConVar g_MoneyHostageRescue;
extern ConVar g_HealthHostageRescue;

extern ConVar g_BehaviourPointsGreetings;
extern ConVar g_BanPointsGreetings;
extern ConVar g_MoneyGreetings;
extern ConVar g_HealthGreetings;

extern ConVar g_TeamFlashMinimumPlayers;
extern ConVar g_TeamFlashMinimumDuration;
extern ConVar g_BehaviourPointsTeamFlash;
extern ConVar g_BanPointsTeamFlash;
extern ConVar g_MoneyTeamFlash;
extern ConVar g_HealthTeamFlash;

extern ConVar g_BehaviourPointsTeamFlashApology;
extern ConVar g_BanPointsTeamFlashApology;
extern ConVar g_MoneyTeamFlashApology;
extern ConVar g_HealthTeamFlashApology;

#endif //_INCLUDE_CVARS_H
