/*
    ServerWiper, watch a Source server to punish bad behaviour
    Copyright (C) 2007-2008  Jonathan "Jmgr" Mercier-Ganady

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact e-mail : sw@jmgr.info
*/

#include "event.h"

#ifdef _WIN32
#pragma warning(disable: 4005)
#endif

Event::Event()
{
    type = 0;
    indexAuthor = -1;
}

Event::~Event()
{
}

void Event::setAuthor(int const& index)
{
    indexAuthor = index;
}

void Event::setVictim(int const& index)
{
    indexVictim = index;
}

void Event::setText(shString const& text)
{
    this->text = text;
}

void Event::setSecondText(shString const& text)
{
    this->text2 = text;
}

void Event::setType(int const& type)
{
    this->type = type;
}

void Event::setEdict(edict_t *edict)
{
    playerEdict = edict;
}

void Event::setIntValue(int const& value)
{
    intValue = value;
}

int Event::getAuthor()
{
    return indexAuthor;
}

int Event::getVictim()
{
    return indexVictim;
}

shString Event::getText()
{
    return text;
}

shString Event::getSecondText()
{
    return text2;
}

int Event::getType()
{
    return type;
}

edict_t *Event::getEdict()
{
    return playerEdict;
}

int Event::getIntValue()
{
    return intValue;
}

