/*
    ServerWiper, watch a Source server to punish bad behaviour
    Copyright (C) 2007-2008  Jonathan "Jmgr" Mercier-Ganady

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact e-mail : sw@jmgr.info
*/

#ifndef _INCLUDE_EVENT_H
#define _INCLUDE_EVENT_H

#include <edict.h>
#include "util.h"

//Player events
const int EVENT_TYPE_PLAYER_CONNECTED			=		0;
const int EVENT_TYPE_PLAYER_DISCONNECTED	    =		1;
const int EVENT_TYPE_PLAYER_JOINTEAM			=		2;
const int EVENT_TYPE_PLAYER_SAY				    =		3;
const int EVENT_TYPE_PLAYER_ATTACKED			=		4;
const int EVENT_TYPE_PLAYER_TA				    =		5;
const int EVENT_TYPE_PLAYER_KILLED			    =		6;
const int EVENT_TYPE_PLAYER_TK				    =		7;
const int EVENT_TYPE_PLAYER_PLANTED_BOMB		=		8;
const int EVENT_TYPE_PLAYER_DEFUSED_BOMB		=		9;
const int EVENT_TYPE_PLAYER_KILLED_HOSTAGE	    =		10;
const int EVENT_TYPE_PLAYER_USED_HOSTAGE		=		11;
const int EVENT_TYPE_PLAYER_RESCUED_HOSTAGE	    =		12;
const int EVENT_TYPE_PLAYER_ATTACKED_HOSTAGE    =		13;
const int EVENT_TYPE_PLAYER_SUICIDED			=		14;
const int EVENT_TYPE_PLAYER_CHANGED_NAME		=		15;
const int EVENT_TYPE_PLAYER_TEAM_FLASH		    =		16;

//Advanced events
const int EVENT_TYPE_PLAYER_INSULT			    =		17;
const int EVENT_TYPE_PLAYER_GREETINGS		    =		18;
const int EVENT_TYPE_PLAYER_APOLOGIES_FOR_TA	=		19;
const int EVENT_TYPE_PLAYER_APOLOGIES_FOR_TK	=		20;
const int EVENT_TYPE_PLAYER_APOLOGIES_FOR_INSULT=		21;
const int EVENT_TYPE_PLAYER_APOLOGIES_FOR_TF    =		22;
const int EVENT_TYPE_PLAYER_LEAVER              =		23;

//Menu events
const int EVENT_TYPE_MENU_FORGIVE               =       24;
const int EVENT_TYPE_MENU_PUNISH                =       25;

const int EVENT_TYPE_MAX                        =       26;

class Event
{
public:
    Event();
    ~Event();

    void setAuthor(int const& index);
    void setVictim(int const& index);
    void setText(shString const& text);
    void setSecondText(shString const& text);
    void setType(int const& type);
    void setEdict(edict_t *edict);
    void setIntValue(int const& value);

    int getAuthor();
    int getVictim();
    shString getText();
    shString getSecondText();
    int getType();
    edict_t *getEdict();
    int getIntValue();

private:
    int type;
    int indexAuthor;
    int indexVictim;
    edict_t *playerEdict;
    shString text;
    shString text2;
    int intValue;
};

#endif //_INCLUDE_EVENT_H



