/*
    ServerWiper, watch a Source server to punish bad behaviour
    Copyright (C) 2007-2008  Jonathan "Jmgr" Mercier-Ganady

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact e-mail : sw@jmgr.info
*/

#ifndef _INCLUDE_INSULTS_H
#define _INCLUDE_INSULTS_H

#include "util.h"
#include "serverWiper.h"

class Insult
{
public:
    Insult()                            {insult = ""; level = 0;}

    void setInsult(shString const& insult)			{this->insult = insult;}
    void setLevel(int const& level)					{this->level = level;}
    shString getInsult()							{return insult;}
    int getLevel()									{return level;}

private:
    shString insult;
    int level;
};

class InsultManager : public Singleton <InsultManager>
{
    friend class Singleton <InsultManager>;

public:
    InsultManager();
    ~InsultManager();

    void loadInsults(shString const& filename, int const& level);
    void reset();

    int getInsultLevel(shString const& text, shString &insult);

private:
    void addInsult(shString const& insult, int const& level);

    shVector <Insult>insults;
};

#endif //_INCLUDE_INSULTS_H
