/*
    ServerWiper, watch a Source server to punish bad behaviour
    Copyright (C) 2007-2008  Jonathan "Jmgr" Mercier-Ganady

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact e-mail : sw@jmgr.info
*/

#ifndef _LANGUAGE_H
#define _LANGUAGE_H

#include "util.h"
#include "serverWiper.h"

class LanguageManager : public Singleton <LanguageManager>
{
    friend class Singleton <LanguageManager>;

public:
    LanguageManager();
    ~LanguageManager();

    bool loadLanguageFile(shString const& filename);
    shString translatedString(char *str, ...);

private:
    shHash<int, shString> baseStrings;
    shHash<int, shString> translations;
    int stringCount;
};

#define _ LanguageManager::getInstance()->translatedString

#endif //_LANGUAGE_H


