/*
    ServerWiper, watch a Source server to punish bad behaviour
    Copyright (C) 2007-2008  Jonathan "Jmgr" Mercier-Ganady

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact e-mail : sw@jmgr.info
*/

#ifndef _INCLUDE_MENU_H
#define _INCLUDE_MENU_H

#include "util.h"
#include "serverWiper.h"

const int MENU_FORGIVE          =       0;
const int MENU_SELECT_PLAYER    =       1;//TODO
const int MENU_ADMIN            =       2;
const int MENU_PLAYER_ADMIN     =       3;//TODO
const int MENU_SERVER_ADMIN     =       4;
const int MENU_SETTINGS         =       5;
const int MENU_BEHAV_TOP        =       6;
const int MENU_BAN_TOP          =       7;

class MenuManager : public Singleton <MenuManager>
{
    friend class Singleton <MenuManager>;

public:
    MenuManager();
    ~MenuManager();

    void showAdminMenu(int const& player);
    void showTopMenu(int const& player, bool behav);
    void showPlayerAdminMenu(int const& player);
    void showServerAdminMenu(int const& player);
    void showSettingsMenu(int const& player);
    void showForgiveMenu(int const& player, int const& killer, int const& time_left);

    void showPlayerListMenu(int const& player, shString const& title);

    void onPlayerMenuSelect(int playerindex, int menu);

private:
    void showMenu(shString const& title, int const& player, shVector<shString> const& options, bool showPage, int const& page, int const& maxpage, bool showPrevious, bool showNext, int const& timeout);
};

#endif //_INCLUDE_MENU_H

