/*
    ServerWiper, watch a Source server to punish bad behaviour
    Copyright (C) 2007-2008  Jonathan "Jmgr" Mercier-Ganady

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact e-mail : sw@jmgr.info
*/

#include "player.h"
#include "serverWiper.h"
#include "cvars.h"

PlayerEvent::PlayerEvent()
{
    status = EVENT_STATUS_NEVER_OCCURED;
    lastOccured = 0;
    banPointsLost = 0;
    behavPointLost = 0;
    count = 0;
	occured = 0;
}

Player::Player(int const& newIndex, edict_t *newEdict)
{
    index = -1;
    edict = newEdict;

    if(!edict && CVAR_INT(g_DebugLevel))
    {
        META_LOG(g_PLAPI,"Got a bad edict");
        return;
    }

    index = ServerWiper::getInstance()->getEngine()->IndexOfEdict(edict);
    setHasSteamID(false);

    setBehavPoints(CVAR_INT(g_MaxBehavPoints));
    setBanPoints(CVAR_INT(g_MaxBanPoints));
    setUsedHostageCount(0);
    setPlayTime(0);
    setActualMenu(-1);
    setActualPage(0);
    setActualMenuTimeout(0);
    setAdmin(false);
	setKickCount(0);
	setBanCount(0);

    data.lastEvent = -1;
    data.gotKicked = false;
    data.lastEventTime = 0;
}

Player::Player()
{
}

Player::~Player()
{
}
