/*
    ServerWiper, watch a Source server to punish bad behaviour
    Copyright (C) 2007-2008  Jonathan "Jmgr" Mercier-Ganady

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact e-mail : sw@jmgr.info
*/

#ifndef _INCLUDE_SINGLETON_H
#define _INCLUDE_SINGLETON_H

template <typename T> class Singleton
{
protected:
    Singleton()  {}
    ~Singleton() {}

public:
    static T *getInstance()
    {
        if(!_singleton)
        {
            _singleton = new T;
        }

        return (static_cast<T*>(_singleton));
    }

    static void kill()
    {
        if(_singleton)
        {
            delete _singleton;
            _singleton = NULL;
        }
    }

private:
    // Unique instance
    static T *_singleton;
};

template <typename T>T *Singleton<T>::_singleton = NULL;

#endif //_INCLUDE_SINGLETON_H

