/*
    ServerWiper, watch a Source server to punish bad behaviour
    Copyright (C) 2007-2008  Jonathan "Jmgr" Mercier-Ganady

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed inp the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact e-mail : sw@jmgr.info
*/

#ifndef _UTIL_H
#define _UTIL_H

#include "sh_string.h"
#define shString SourceHook::String
#include <sh_vector.h>
#define shVector SourceHook::CVector
#include <sh_stack.h>
#define shStack SourceHook::CStack
#include <sh_tinyhash.h>
#define shHash SourceHook::THash

#include <time.h>

const int MAX_NAME_LENGTH       =       30;

shString itos(int const& value);
shString trimText(shString const& text);
shString getSpacedString(shString const& text);
shString deleteFromString(shString const& text, char toDelete);
shString getCleanedString(shString const& text);
shString getLowerString(shString const& text);
shString getToken(shString const& text, int const& num);
shString getIntegerChangeFormatted(int const& value);
shString boolToString(bool status);
bool isPatternInString(shString const& string, shString const& pattern);
shString cleanString(shString const& string, int const& maxlen);
shString cutString(shString & string, int const& size);
template <class T> T getMax(T a, T b)                        {return a > b ? a : b;}
template <class T> T getMax(T a, T b, T c)                   {return getMax(getMax(a,b),c);}
template <class T> T getMax(T a, T b, T c, T d)              {return getMax(getMax(a,b,c),d);}
template <class T> T getMax(T a, T b, T c, T d, T e)         {return getMax(getMax(a,b,c,d),e);}
template <class T> T getMax(T a, T b, T c, T d, T e, T f)    {return getMax(getMax(a,b,c,d,e),f);}

#endif //_UTIL_H
